CREATE DATABASE GRADIUS;

USE GRADIUS;

CREATE TABLE JOGADOR (
	COD INT PRIMARY KEY IDENTITY(1,1),
	MAIL VARCHAR(100) NOT NULL UNIQUE,
	NICK VARCHAR(20) NOT NULL UNIQUE,
	SENHA VARCHAR(200) NOT NULL
);

CREATE TABLE PARTIDA (
	COD INT PRIMARY KEY IDENTITY(1,1),
	JOGADOR1 INT NOT NULL,
	JOGADOR2 INT NOT NULL,
	MORTE1 INT DEFAULT 0, -- NUMERO DE MORTES DO JOGADOR 1
	MORTE2 INT DEFAULT 0, -- NUMERO DE MORTES DO JOGADOR 2
	CONSTRAINT FK_PARTIDA_JOGADOR1 FOREIGN KEY(JOGADOR1) REFERENCES JOGADOR(COD),
	CONSTRAINT FK_PARTIDA_JOGADOR2 FOREIGN KEY(JOGADOR2) REFERENCES JOGADOR(COD)
);

CREATE TABLE OBSTACULO (
	COD INT PRIMARY KEY IDENTITY(1,1),
	NOME VARCHAR(40) NOT NULL,
	VIDA INT NOT NULL CHECK (VIDA > 0),
	PONTO INT NOT NULL CHECK (PONTO > 0),
	-- INTERVALO EM SEG QUE O OBSTACULO TEM A CHANCE DE APARECER NA PARTIDA 
	INTERVALO INT NOT NULL CHECK (INTERVALO = 10 OR INTERVALO = 20 OR INTERVALO = 30  
	OR INTERVALO = 40  OR INTERVALO = 50  OR INTERVALO = 60)
);

CREATE TABLE ESTATISTICA (
	COD INT PRIMARY KEY IDENTITY(1,1),
	PARTIDA INT NOT NULL,
	OBSTACULO INT NOT NULL,
	VIDA INT NOT NULL,
	ASSASSINO INT,
	CONSTRAINT FK_ESTATISTICA_PARTIDA FOREIGN KEY(PARTIDA) REFERENCES PARTIDA(COD),
	CONSTRAINT FK_ESTATISTICA_OBSTACULO FOREIGN KEY(OBSTACULO) REFERENCES OBSTACULO(COD)
);